val nf : Rules.t -> Term.t -> Term.t

val rewrite : Rules.t -> Term.t -> Term.t list

val root_step : Rules.t -> Term.t -> Term.t list

val multistep : Rules.t -> Term.t -> Term.t list

val parallel_step : Rules.t -> Term.t -> Term.t list

val reachable : int -> Rules.t -> Term.t list -> Term.t list

val reachable_all : Rules.t -> Term.t list -> Term.t list

val joinable : int -> Rules.t -> Term.t * Term.t -> bool

